Bug 1625276 - Review Request: radare2 - The reverse engineering framework
Summary: Review Request: radare2 - The reverse engineering framework
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1368855 (view as bug list)
Depends On:
Blocks: FE-SECLAB
TreeView+ depends on / blocked
 
Reported: 2018-09-04 14:24 UTC by Riccardo Schirone
Modified: 2018-09-20 14:08 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-09-20 05:16:44 UTC
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Riccardo Schirone 2018-09-04 14:24:00 UTC
Spec URL: https://raw.githubusercontent.com/ret2libc/radare2/spec-file/radare2.spec
SRPM URL: https://github.com/ret2libc/radare2/blob/spec-file/radare2-2.9.0-1.fc27.src.rpm?raw=true

radare2 is a reverse engineering framework which provides tools to analyze files and binaries, disassemble code, debug programs and much more. It also provides a set of libraries to let you build your own tools.

This package review request was created given that https://bugzilla.redhat.com/show_bug.cgi?id=1368855 was stalled for quite some time because of no replies from both the submitter and the reviewer. The Spec file is partially based on https://rebus.fedorapeople.org/SPECS/radare2.spec, but it uses the meson build system recently improved in radare2 upstream.

Fedora Account System Username: rschiron

Comment 1 Robert-André Mauchin 2018-09-04 14:37:13 UTC
>Fedora Account System Username: rschiron

I can't find any account under that name on your email.

Comment 2 Riccardo Schirone 2018-09-04 14:42:19 UTC
>>Fedora Account System Username: rschiron
>
>I can't find any account under that name on your email.

You are right, I made a mistake. My username is `ret2libc`.

Comment 3 Robert-André Mauchin 2018-09-04 14:54:22 UTC
 - Not needed anymore for >= F28

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

   Use %ldconfig_scriptlets if you need F27

 - Globbing the major soname version is now forbidden to prevent accidental soname bump:

%{_libdir}/libr*.so.*

   Be more specific instead.

 - %global         build_release    1

Use a %bcond_with/%bcond_without mechanism. See http://rpm.org/user_doc/conditional_builds.html

 - Source0:        https://github.com/%{gituser}/%{gitname}/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz

→

Source0:        https://github.com/%{gituser}/%{gitname}/archive/%{version}/%{name}-%{version}.tar.gz

 - Add gcc as a BR

Comment 4 Robert-André Mauchin 2018-09-04 14:56:05 UTC
Blocking FE-NEEDSPONSOR.

You also need to find a sponsor to get into the packager group: https://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group

Comment 5 Riccardo Schirone 2018-09-04 16:40:21 UTC
Thanks, Robert-André

I've updated the SPEC/SRPM files to address your comments.
I'm also working on getting a sponsor.

Comment 6 M. Scherer 2018-09-04 16:43:22 UTC
I am ok to sponsor Riccardo, (and did already the change in FAS)

Comment 7 Robert-André Mauchin 2018-09-04 17:37:12 UTC
Perfect.

 - radare2.x86_64: W: invalid-license ASLv2.0

The license shorthand for Apache is "ASL 2.0"


Package is approved, please fix the license issue before import.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL", "GPL (v2) (with incorrect FSF address)", "*No copyright*
     CC0", "BSD (3 clause)", "GPL (v1 or later)", "LGPL (v2 or later)",
     "GPL (v3 or later)", "GPL (v2 or later) (with incorrect FSF address)",
     "BSD (2 clause)", "GPL (v3)", "Apache (v2.0)", "GPL (v2 or later)",
     "LGPL (v3.0 or later)", "MIT/X11 (BSD like)", "BSD (3 clause) GPL (v3
     or later)", "*No copyright* Public domain", "MPL (v1.1) GPL (v2 or
     later)", "BSD (unspecified)", "*No copyright* GPL LGPL", "LGPL",
     "Unknown or generated", "BSD (4 clause)", "NTP". 2147 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/radare2/review-radare2/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 133120 bytes in 35 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
     Note: Multiple Release: tags found
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     radare2-debuginfo , radare2-debugsource
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: radare2-2.9.0-1.fc30.x86_64.rpm
          radare2-devel-2.9.0-1.fc30.x86_64.rpm
          radare2-common-2.9.0-1.fc30.noarch.rpm
          radare2-debuginfo-2.9.0-1.fc30.x86_64.rpm
          radare2-debugsource-2.9.0-1.fc30.x86_64.rpm
          radare2-2.9.0-1.fc30.src.rpm
radare2.x86_64: W: spelling-error %description -l en_US scriptable -> scrip table, scrip-table, script able
radare2.x86_64: W: spelling-error %description -l en_US opcode -> op code, op-code, code
radare2.x86_64: W: invalid-license ASLv2.0
radare2.x86_64: W: shared-lib-calls-exit /usr/lib64/libr_core.so.2.9.0 exit@GLIBC_2.2.5
radare2.x86_64: W: shared-lib-calls-exit /usr/lib64/libr_crypto.so.2.9.0 exit@GLIBC_2.2.5
radare2.x86_64: W: shared-lib-calls-exit /usr/lib64/libr_egg.so.2.9.0 exit@GLIBC_2.2.5
radare2.x86_64: W: shared-lib-calls-exit /usr/lib64/libr_lang.so.2.9.0 exit@GLIBC_2.2.5
radare2.x86_64: W: shared-lib-calls-exit /usr/lib64/libr_parse.so.2.9.0 exit@GLIBC_2.2.5
radare2.x86_64: W: no-manual-page-for-binary r2
radare2-devel.x86_64: W: invalid-license ASLv2.0
radare2-devel.x86_64: W: no-documentation
radare2-common.noarch: W: invalid-license ASLv2.0
radare2-debuginfo.x86_64: W: invalid-license ASLv2.0
radare2-debugsource.x86_64: W: invalid-license ASLv2.0
radare2.src: W: spelling-error %description -l en_US scriptable -> scrip table, scrip-table, script able
radare2.src: W: spelling-error %description -l en_US opcode -> op code, op-code, code
radare2.src: W: invalid-license ASLv2.0
radare2.src:111: W: unversioned-explicit-provides bundled(js0n)
radare2.src:137: W: unversioned-explicit-provides bundled(grub2)
6 packages and 0 specfiles checked; 0 errors, 19 warnings.

Comment 8 Gwyn Ciesla 2018-09-05 13:07:02 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/radare2

Comment 9 Riccardo Schirone 2018-09-06 08:41:53 UTC
*** Bug 1368855 has been marked as a duplicate of this bug. ***

Comment 10 Riccardo Schirone 2018-09-06 08:49:13 UTC
I'm doing some adjustments to the package as I've seen some issues while running it on koji. Moreover, I'd appreciate if you could have another look at the SPEC file. Things I've done:

- adjust the license as you said
- add some patches
- switch to %autosetup
- make -common subpackage Requires `%{name} = %{version}-%{release}` instead of `%{name}%{?_isa} = %{version}-%{release}`

I have also closed the previous review request at bz 1368855 .

Comment 11 Robert-André Mauchin 2018-09-06 10:24:26 UTC
It would be nice to add comments explaining why the patch are needed/what they do.

Otherwise it's OK.

Comment 12 Fedora Update System 2018-09-09 14:51:19 UTC
radare2-2.9.0-1.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-4d8d632107

Comment 13 Fedora Update System 2018-09-09 14:52:18 UTC
radare2-2.9.0-1.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2018-61ad52701f

Comment 14 Fedora Update System 2018-09-11 15:43:38 UTC
radare2-2.9.0-1.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-61ad52701f

Comment 15 Fedora Update System 2018-09-11 18:10:47 UTC
radare2-2.9.0-1.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-4d8d632107

Comment 16 Fedora Update System 2018-09-20 05:16:44 UTC
radare2-2.9.0-1.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2018-09-20 11:16:46 UTC
radare2-2.9.0-1.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2018-09-20 14:08:48 UTC
radare2-2.9.0-1.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.